/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *                2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN    
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_defs.h,v 1.2 2006/12/25 07:17:56 honda Exp $
 */


/*
 *  åȥƥ˰¸ARM CT11MPCore with the RealView Emulation Boardѡ
 *
 *  Υ󥯥롼ɥեϡkernel.h  sil.h ǥ󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥
 *  롼ɤˡt_stddef.h  itron.h 󥯥롼ɤΤǡ
 *  ˰¸Ƥ褤
 */

#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*
 *  ưåΥåȥƥ̾
 */
#ifdef PE1
#define TARGET_NAME    "ARM MPCore0 - CT11MPCore with the RealView Emulation Board"
#elif  PE2
#define TARGET_NAME    "ARM MPCore1 - CT11MPCore with the RealView Emulation Board"
#elif  PE3
#define TARGET_NAME    "ARM MPCore2 - CT11MPCore with the RealView Emulation Board"
#elif  PE4
#define TARGET_NAME    "ARM MPCore3 - CT11MPCore with the RealView Emulation Board"
#endif


/*
 * ե졼¸
 */

/*
 * ץåֹ(03)
 */
#ifdef PE1
#define PRCID 1
#elif defined(PE2)
#define PRCID 2
#elif defined(PE3)
#define PRCID 3
#elif defined(PE4)
#define PRCID 4
#endif  /* PE1 */


/*
 * 
 */ 
/*
 * ƥץåΥȥɥ쥹
 */ 
#define CORE0_START_ADDER   0x01000000
#define CORE1_START_ADDER   0x02000000
#define CORE2_START_ADDER   0x03000000
#define CORE3_START_ADDER   0x04000000

/*
 * 󥿥ƥѤΥåν
 */
#ifdef PE1
#define STACKTOP 0x02000000   
#elif defined(PE2)
#define STACKTOP 0x03000000   
#elif defined(PE3)
#define STACKTOP 0x04000000   
#elif defined(PE4)
#define STACKTOP 0x05000000   
#endif  /* PE4 */

/*
 * ץåֳߤ˻ѤߤID
 */
#define INTERPROCLVL 0

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK 1000

/*
 *  MPCore¢Υޤ1MZư뤿Υץꥹ顼
 */
#define MPCORE_TM_PS_1MHZ    99   /* å200Mhz */

/*
 *  ƥå
 */
#define TIC_NUME    1        /* ƥåμʬ */
#define TIC_DENO    1        /* ƥåμʬ */

/*
 * ѤUART
 * 03ǽ(2,3ˤĤƤϥɤ̤)
 */
#ifdef PE1
#define EB_UART_NO  0
#elif defined(PE2)
#define EB_UART_NO  1
#elif defined(PE3)
#define EB_UART_NO  2
#elif defined(PE4)
#define EB_UART_NO  3
#endif  /* PE1 */


/*
 * GICѤ뤫
 * UART2,3GIC1,GIC2³
 * GICλȤʬʤΤDICľ뤹褦˥ܡɥեѹ  
 */
#ifdef PE2
//#define USE_GIC1
#elif defined(PE3)
//#define USE_GIC2
#endif  /* PE */


/*
 * ͥ(0x000x0f)
 *  0x00ǹͥ 
 */ 
#define EB_UART_INT_LEVEL    0x01  /* UARTͥ */
#define MPCORE_TM_INT_LEVEL  0x00  /* ޡͥ */ 

/*
 *  åȥƥ¸Υӥ
 */
#ifndef _MACRO_ONLY

/*
 *  INTNOȳߤζػ/
 */
typedef    UINT        INTNO;        /* ֹ */
typedef    UINT        INHNO;        /* ߥϥɥֹ */


typedef    UD  SYSUTIM;    /* ǽɾѥƥ */
extern ER   vxget_tim(SYSUTIM *pk_sysutim) throw();

#endif /* _MACRO_ONLY */

/*
 *  ԤΤ
 */
#define    SIL_DLY_TIM1     20
#define    SIL_DLY_TIM2     10

/*
 *  ץåΥǥ
 */
#define    SIL_ENDIAN    SIL_ENDIAN_LITTLE    /* ȥ륨ǥ */

#ifndef _MACRO_ONLY
/*
 * ƥǽ
 */

Inline void
kernel_abort()
{
   while(1);
}

#endif /* _MACRO_ONLY */

#endif /* _SYS_DEFS_H_ */
