/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003      by Advanced Data Controls, Corp
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_support.S,v 1.1 2006/09/21 07:16:56 honda Exp $
 */

#define _MACRO_ONLY
#include "fdmp_kernel.h"
#include "ct11mpcore_eb.h"
        
/*
 *  ٥Υåȥƥ¸νARM MPCore ѡ
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥          
 */       

        .text
        .align 2
        .global hardware_init_hook
hardware_init_hook: 

init_done:
        mov     pc, lr


        .text
        .align 2
        .global software_init_hook
software_init_hook:
        mov     pc, lr

        .text
        .align 2
        .global software_term_hook
software_term_hook:
        mov     pc, lr


/*
 *
 *  ߤν
 *         
 */        
        .text
        .align 4    
        .global IRQ_Handler
IRQ_Handler:

        /* 
         * ߥ⡼ 
         * 
         * cpsrspsr_irq褬r14_irq(lp)ꡤ
         * spsr_irqr14_irqr13(sp)_irq r14,r13Ȥʤ롥
         */

        /* 
         *  ư⡼(ѡХ⡼)
         */
//        mov   sp,#(CPSR_SVC | CPSR_FIQ_BIT | CPSR_IRQ_BIT) 
//        msr   cpsr_all, sp
//        stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

 
  
        /*
         * spsrϤ뤿IRQ⡼ɤ
         */
        mov   r0,#(CPSR_IRQ | CPSR_FIQ_BIT | CPSR_IRQ_BIT)
        msr   cpsr,r0
        sub   r0,lr,#4
        mrs   r1,spsr
   
        /*
         *  ѡХ⡼ɤ
         */
        and   r2,  r1, #CPSR_FIQ_BIT /* FIQӥåȤηѾ */
        orr   r2,  r2, #(CPSR_SVC|CPSR_IRQ_BIT)        
        msr   cpsr_all, r2
        str   r0, [sp,#0x18] /* Store pc */
        stmfd sp!,{r1}       /* spsr */


        /*
         *  ¿ųߤȽ
         */
        ldr     r2, =interrupt_count
        ldr     r3, [r2]
        add     r0,r3,#1
        str     r0, [r2]
        cmp     r3, #0x00

        moveq   r2,sp            /* ͥȳߤǤʤ */
        ldreq   sp,=STACKTOP     /* åѹ    */
        stmeqfd sp!,{r2}         /* å¸ */


        /*
         *  װȽꡥ
         */
        ldr     r0,=MPCORE_DIC_CPUIF_IAR
        ldr     r1,[r0] 
		mov	    r1, r1, asl #22  /* 9ӥåȰʳ򥯥ꥢ */
		mov	    r1, r1, lsr #22
		ldr     r2,=int_table    /*  ߥơ֥ɤ߹ */
		ldr	    r0, [r2, r1, asl #2] 	/* r0<-ߥϥɥ            */    


#if defined(USE_GIC1)
		cmp     r1, #DIC_INTID_EB_UART2
#endif		
#if defined(USE_GIC2)
		cmp     r1, #DIC_INTID_EB_UART3
#endif		
#if defined(USE_GIC1) || defined(USE_GIC2)
		bne     _end_gic_enter
		ldr     r2, =(EB_GIC_BASE + EB_GIC_CPUIF_ACK) /* IDФ */
		ldr     r3, [r2]
		stmfd   sp!,{r3} 
		ldr     r2, =(EB_GIC_BASE + EB_GIC_CPUIF_PR) /* ͥ٤Ф */
		ldr     r3, [r2]
		stmfd   sp!,{r3} 
		ldr     r2, =(EB_GIC_BASE + EB_GIC_CPUIF_RPR) /* ͥ٤Ф */
		ldr     r3, [r2]
		ldr     r2, =(EB_GIC_BASE + EB_GIC_CPUIF_PR) /* ͥ٤Ф */
		str     r3, [r2]
_end_gic_enter:
#endif

		stmfd sp!,{r1} /* EOIΤ˳ֹ¸ */


        /*
         *  ̤γߤå
         */
        cmp     r0, #0x00
        beq     undefined_interrupt
        

		/*
		 * ߥޥѹ
		 */
        ldr     r2,=MPCORE_DIC_CPUIF_RII
        ldr     r1,[r2] 
        ldr     r2,=MPCORE_DIC_CPUIF_PMR
        ldr     r3,[r2] 
        str     r1,[r2] 
        stmfd sp!,{r3}          /* γͥ٤¸ */

        /* 
         * ߵ 
         */                
        mrs     r2, cpsr
        and     r2,  r2, #~CPSR_IRQ_BIT /* ߵ */
        msr     cpsr,r2

        /* 
         * Call Handler  
         */        
        mov     lr,  pc   
        mov     pc,  r0

        /* 
         * ߶ػ 
         */
        mrs     r2, cpsr
        and     r2,  r2, #CPSR_FIQ_BIT /* FIQӥåȤηѾ */         
        orr     r2,  r2, #(CPSR_SVC|CPSR_IRQ_BIT)
        msr     cpsr,r2

		ldmfd   sp!,{r3}               /* ͥ٤ */
	    ldr     r2,=MPCORE_DIC_CPUIF_PMR
		str     r3,[r2]

	    /*
         * EOI
         */
		ldmfd   sp!,{r1}               /* EOIΤ˳ֹ */


#if defined(USE_GIC1)
		cmp     r1, #DIC_INTID_EB_UART2
#endif		
#if defined(USE_GIC2)
		cmp     r1, #DIC_INTID_EB_UART3
#endif		
#if defined(USE_GIC1) || defined(USE_GIC2)
		bne     _end_gic_reave
		ldmfd   sp!,{r0}               /* ͥ٤ */
		ldr     r2, =(EB_GIC_BASE + EB_GIC_CPUIF_PR) /* ͥ٤Ф */
		str     r0, [r2]
		ldmfd   sp!,{r0}                             /* EOI */
		ldr     r2, =(EB_GIC_BASE + EB_GIC_CPUIF_EOI) 
		str     r0, [r2]
_end_gic_reave:
#endif

		ldr     r0,=MPCORE_DIC_CPUIF_EOI
		str     r1,[r0]                /* EOI쥸ؤν񤭹 */


        /* 
         * ߥͥȲ(interrupt_count) ǥ 
         */
        ldr     r2, =interrupt_count
        ldr     r1, [r2]        
        sub     r3, r1, #1                        
        str     r3, [r2]
        cmp     r3, #0x00        
        bne     return_to_task_irq
        
        /* 
         * å 
         */
        ldmfd   sp!,{r0}         
        mov     sp, r0        
                
        ldr     r1, =reqflg    /* Check reqflg */
        ldr     r0, [r1]
        cmp     r0, #0
        beq     return_to_task_irq
        mov     r0, #0
        str     r0, [r1]       /* Clear reqflg */
        b       ret_int

return_to_task_irq:
        /*
         *  
         *  ߵĤȤʤ뤬ƥȾ¸Ƥ뤿ᡤ
         *  Ϥʤ
         */
        ldmfd   sp!,{r1}           /* CPSR */
        mrs     r2, cpsr           /* FIQѾ            */
        and     r2, r2, #CPSR_FIQ_BIT
        and     r1, r1, #~CPSR_FIQ_BIT
        orr     r1, r1, r2                 
        msr     spsr, r1              /* cpsrspsr */
        ldmfd   sp!,{r0-r3,ip,lr,pc}^ /*  ^դʤΤǡcpsr <- spsr */        

        /*
         *  ̤γߤäȤ˸ƤӽФ
         */    
undefined_interrupt:
         b      undef_interrupt
    

