/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mp_config.h,v 1.2 2006/09/21 07:38:08 honda Exp $
 */

/** \file
 *  ޥץåݡȥ⥸塼 إåեARMѡ
 */

#ifndef _MP_CONFIG_H_
#define _MP_CONFIG_H_

#include "arm.h"

#define MASTER_PROC() (PRCID == 1)

#ifndef _MACRO_ONLY

/*
 * åȥ֥ȥå
 */
extern UW    tsk_lock;
extern UW    obj_lock;

/**
 * åν
 *   ͤEXCCBtsk_lock_ptrϿ 
 */
Inline VP
init_tsk_lock()
{
	tsk_lock = 0;
    return((VP)(&tsk_lock));
}


/**
 * ֥ȥåν
 *   ͤEXCCBobj_lock_ptrϿ
 */
Inline VP
init_obj_lock()
{
    obj_lock = 0;
    return((VP)(&obj_lock));
}

#include "ct11mpcore_eb.h"

/**
 *  ץåֳߤȯ
 */
Inline void
raise_ipi(INT procid)
{
	mpcore_dic_swi((1<<procid), INTERPROCLVL);
}

/**
 *  ץåֳߤΥꥢ
 */
Inline void
clear_ipi(void)
{

}

/**
 *  ץå߲ϩ˴ؤ
 */
Inline void
hw_ipi_initialize(void)
{

}

/**
 *
 */
Inline VP
memset(VP str, INT ch, UINT len)
{
    VB *s = str;

    while (len-- > 0) {
        *s++ = ch;
    }
    return(str);
}

/*
 *  ͥ뵯ưCCBνѴؿ
 */

/**
 *  ƱѤΥǡ(ޥץåΤ߼¹)
 */
extern void mp_initialize(void);

/**
 *  ޥץåˤԤ(ޥץåʳ¹)
 */
extern void mp_init_sync(void);


/**
 *  ƤΥץåEXCCBνԤ
 */
extern void mp_start(void);


#endif /* _MACRO_ONLY */
#endif /* _MP_CONFIG_H_ */
