/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel  
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: startup.c,v 1.6 2006/09/15 13:48:38 honda Exp $
 */


/** \mainpage

  TOPPERS-FDMP(Function Distributed Multi Processor) ͥ
   - Ϥ
     - ܥͥϡJSP 1.4.1 ١˵ǽʬޥץå
       ĥΤǤ롥

  
   - @todo Ƥ(̤⤯̤)
     - ROMΰ˸ʤƤư褦ˤ
         - ֥åͤΤAPIǿɬפΤΤϴ
           ֥å˥ԡ롥
           ->ɬפФ
     - ե졼CCBˡƤ
     - enadspͭѿȤ뤫(CCB뤫)

   - 
     - ץåΥǥ쥯ȥɤ뤫
        -> ץåˤϥƥ¸ʬʤ
            ->OMAP٥ΥإƥξӸƤ      
     - ץåֳ
       ͥ볰ʤΤ ͥʤΤ
       ipi_initialize(VP_INT exinf) kernel_start()Ƥ֤٤
       ȤATT_INI()ǸƤӽФ٤
       ->ʤ
  
   - FDMPưƥ
     - FDMPư뤿ˤϡʲΥƥɬפ
       - ƥץåΥǡ(rodataޤ)֤꤬
         ߤ˥ǽƤΥץå
         Ʊɥ쥹ǥǤɬפ롥
       - ǤդΥץå˳(ץåֳ)ȯǽ
       - ץå֤Ǥ¾ΤεڤӤεѤ
         åץåx2ĺǽǤ뤳ȡ2ĤǤ
         ưϲǽ
         -  : test & set ̿, Mutex ϩ

  
   - ͥ빽ˡ
     - 󥰥ץåȰۤʤˤĤƤΤ롥
     - CFGեѰդ롥
     - FDMPѤΥե졼¹Ԥ롥¹Ԥˤƥץå
       ץå̾ǥ֥ѤΥǥ쥯ȥ(ץåǥ
       ȥ)ưʲΥե뤬롥
         class_id.h, kernel_id.h, kernel_cfg.c
     - class_id.h(饹IDեե)ˤϡ饹IDդΥ֥
       IDƤ롥
       㤨PE1TASK1ȤPE1ʳ饢ˤϡ
       class_id.h 򥤥󥯥롼ɤPE1_TASK1ȤIDAPI¹Ԥ
       褤
     - ƥץåΥץåǥ쥯ȥ make depend ¹Ԥ
       ¸طե塤make ¹Ԥƥͥ륪֥
       Ȥ롥
     - ͥǥ  
       - ܥǥ(륯饹Τ)
         ǥγĥݻ뤿ᡤ饹ȥ֥åѤ
         ǥϻĤƤ

  
   - API
     - API
       - mget_tid(ID clsid, ID *p_tskid)
          ꤷ饹IDΥץåǼ¹ΥID
       - imget_tid(ID clsid, ID *p_tskid)
          ꤷ饹IDΥץåǼ¹ΥID
       - mrot_rdq(ID clsid, PRI tskpri)
          ꤷ饹IDΥץåΥǥ塼󤹡
       - imrot_rdq(ID clsid, PRI tskpri)
          ꤷ饹IDΥץåΥǥ塼󤹡  
     - ѹ
        

   - 
       - å/ǥѥåػ߾֤Ǽ¹ΥФsus_tsk/ter_tsk
         ȯԤ줿ο(ޥƥ)ꡥ
       - 
         - sus_tsk(ID tskid)
           - CPUå/ǥѥåػΥФsus_tsk()ȯԤ
             ȡϰŪ˲Ūʾ(run-suspend)ˤʤ롥
         - ter_tsk(ID tskid)
             - CPUå/ǥѥåػΥФter_tsk()ȯ
               ȡϰŪ˲Ūʾ(run-terminated)ˤʤ롥
	   - ˡ
         - ter_tskȯԤȤ򼨤terflgTCBɲá
         - ret_intǤϤΥե饰åơTRUEȥƥȤ
           ¸˥ǥѥå㡼.
           ret_intǥåΤϰʲĤͳǤ롥
            1. CPUåˡter_tsk()νη̡ȯԤ줿ץ
               åֳߤͭˤʤ뤿Ǥ롥
            2. ߥϥɥ¹Ի(runtskͥ٤⤤)ˡter_tsk()
               ȯԤǽ.
         - terflgΥꥢactivate_rǹԤ
         - activate_context()ϥåĤ֤ʤ褦ѹ
         - sus_tskоݥruntskenadspFALSEʤ顤ߤ
           ȯԤʤ褦ˤ̵̤ʳߤɤ롥
       - sus_tsk(ID tskid)θƤ
         - CPUå֤ runtsk ȯ
            - äкɬפϤʤ
            - sus_tsk()μ¹Ը塤ץåֳߤȯ
            - CPUåAPIȯԤǤʤ
            - CPUåǳߤդ
            - ξ֤suspend˰ܹԤƤ뤿ᡤrsm_tsk()
              ư롥
         - ǥѥåػ߾֤ runtsk ȯ
            - äкɬפϤʤ
            - sus_tsk()¹Ը塤ץåֳߤȯ
            - ߤϵĤƤΤǡߥ롼뤬
               ǥѥåػΤᡤ⤻˥꥿
            - ena_dsp()¹ԤȡǥѥåԤena_dsp()
              ǥåȤ뤿ᡤsus_tsk()ȤΥ졼󥰤ȯ
              ʤ
            - ξ֤suspend˰ܹԤƤ뤿ᡤrsm_tsk()
               ư롥
         - APIȯ
            - CPUå֤ǤϡԤ֤ˤAPIȯԤǤʤ
              ȡʬξ֤ѹǤʤΤᡤAPIȯԤ
              ʤޤext_tsk()ϸ§顼TOPPERSǤϥ
              ˥󥰤ˤƽ
       - ter_tsk(ID tskid)θƤ
         - CPUå֤ runtsk ȯ
            - äкɬפϤʤ
            - CPUåǥץåֳߤǥѥå
              ȯ롥
            - ̤˥Ƥޤåǽ롥
              åʤ褦˽뤳Ȥϲǽ
         - ǥѥåػruntsk ȯ
            - äкɬפϤʤ
         -  APIȯ
            - sus_tsk()Ʊͳʤ
         - terflgåȤϥǥѥå׵(ץåֳ)ȯ˹Ԥ
            - դˤȡץåֳߤνиret_intǡterflgȤ
              줬롥

  
   - ǥåȥå
       - оAPI
         - rel_wai(ID tskid)
         - chg_pri(ID tskid, PRI tskpri)  
         - ter_tsk(ID tskid)
         - ॢ
       - TCBؤɲåȥ
         - BOOL pend_tertsk : ter_tsk(ID tskid) ¹ɽ
         - BOOL pend_chgpri : chg_pri(ID tskid, PRI tskpri)¹ɽ
         - BOOL pend_relwai : Ԥ¹ɽ
         - UINT pend_newpri : ͥѹαοͥ١ɽ                              
       - ॢ(wait_tmout(TCB *tcb))
         - ƥåԤǤʤв⤷ʤƤ褤ॢȽ
           оݥƱץåưƤΤǡоݥϤδ
           ư¾Υ֥Ԥˤʤ뤳ȤϤʤ
       - rel_wai(ID tskid)
         - ƥåˡоݥ̤Ԥ֥ȤФԤ
           ˤʤäƤС⤻E_OBJ֤ƱԤ֤ʤԤ
           E_OK֤
       - chg_pri(ID tskid, PRI tskpri)  
         - ǽΥånewpriTCBϿƥå¾Υ롼
           Ԥֲˤnewpri򸫤ͥ٤ѹƥånewpri
           ͤͭʤƱԤΤϤʤΤ̾ͥѹԤ
       - ter_tsk(ID tskid)
         - ǽΥåTCBpend_tertskTRUEˤƥåԤֲ
           ˤpend_tertsk򸫤TRUEʤ饿λƥå
           pend_tertskTRUEʤƱ֥ȤФԤΤϤʤΤ
           ΥλԤ
       - pend_tertsk/pend_chgpri/pend_relwaiå륿ߥ
         - Ԥ֤ݤ˥å
           - make_non_wait()

  
   - ACUIRE_LOCKȴ
       - ʬԤAPIǳߤػߤƤ饿åޤ
         ˡrunnableǤʤʤäƤǽ롥
       - runnableɤå٥åߤĤ
         ʲΥޥѰա
         - T_ACQUIRE_LOCK_AND_CHECK_RUNNABLE()
         - T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(lockobj1)
       - оAPI
         - snd_dtq(ID dtqid, VP_INT data)
         - tsnd_dtq(ID dtqid, VP_INT data, TMO tmout)
         - rcv_dtq(ID dtqid, VP_INT *p_data)
         - trcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout)
         - wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
         - twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout)
         - rcv_mbx(ID mbxid, T_MSG **ppk_msg)
         - trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout)
         - get_mpf(ID mpfid, VP *p_blk)
         - tget_mpf(ID mpfid, VP *p_blk, TMO tmout)
         - wai_sem(ID semid)
         - twai_sem(ID semid, TMO tmout)
         - dis_dsp(void)
         - slp_tsk()
         - tslp_tsk(TMO tmout)
         - sus_tsk(ID tskid)
         - dly_tsk(RELTIM dlytim)

  
   - ǥ󥰤κݤ
       - NESTED_LOCKѻ
         - XXX_NESTED_LOCK()ϡT_ACQUIRE_LOCK()Ȥδ֤ȥ饤
           ֤¹Ԥ뤿ᡤδ֤˲ɤǤʤФʤʤ  

  
   - ץåֳ
     - ¾ΥץåФƤΥǥѥå׵ϥץåֳߤˤ
       ¸롥
     - Ϣե
       - ./include      : ipi.h
       - ./systask      : ipi.c
       - ./systask      : ipi.cfg
       - ./config/nios2 :  mp_config.h
     - ؿ
       - ipi_initialize(VP_INT exinf) : ץåֳߤν(ATT_INIϿ)                                         
       - ipi_handler(void)            : ץåֳߥϥɥ  
       - raise_ipi(INT prcid)         : ץåֳߤȯ
       - clear_ipi(INT prcid)         : ץåֳߤΥꥢ

  
   - å
     - ֥ȥå  åν˥å
     - Ϣե
       - ./kernel       : lock.h
       - ./config/nios2 : mp_config.h
     - ؿ
       - my_local_acquire_lock(LOCKOBJ *lockobj)
       - my_local_release_lock(LOCKOBJ *lockobj)
       - local_acquire_lock(LOCKOBJ *lockobj)
       - local_release_lock(LOCKOBJ *lockobj)
     - (å)
       - init_tsk_lock()ƤӽФͤexccbtsk_lock_prt
         Ͽ
       - ccbtsk_lock.lock_opsmy_local_acquire_lock
         my_local_release_lockϿ
       - ¾ccbtsk_lock.lock_opslocal_acquire_locklocal_release_lock
         Ͽ
     - åޥ(lock.h)
       - ACQUIRE_LOCK(lockobj)
       - RELEASE_LOCK(lockobj)
       - RELEASE_LOCK_AND_DISPATCH(lockobj, dspreq)
       - T_ACQUIRE_LOCK(lockobj)
           t_lock_cpu()ˤCPUå
       - T_ACQUIRE_LOCK_AND_CHECK_RUNNABLE()
           å塤ξ֤ѲƤХȥ饤롥
           - dis_dsp(void)
           - ena_tex()
           - slp_tsk()
           - tslp_tsk(TMO tmout)
           - dly_tsk(RELTIM dlytim)
       - T_ACQUIRE_NESTED_LOCK(lockobj, lockobj1)
           lockobjΥåǤʤϡlockobj1Υå
           CPUåƥȥ饤
       - T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(lockobj1)
           å塤ξ֤ѲƤХȥ饤롥
           - snd_dtq(ID dtqid, VP_INT data)
           - tsnd_dtq(ID dtqid, VP_INT data TMO tmout)
           - rcv_dtq(ID dtqid, VP_INT *p_data)
           - trcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout)
           - wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
           - twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout)
           - rcv_mbx(ID mbxid, T_MSG **ppk_msg)
           - trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout)
           - get_mpf(ID mpfid, VP *p_blk)
           - tget_mpf(ID mpfid, VP *p_blk, TMO tmout)
           - wai_sem(ID semid)
           - twai_sem(ID semid, TMO tmout)
       - T_RELEASE_LOCK(lockobj)
       - T_RELEASE_NESTED_LOCK(lockobj, lockobj1)
          lockobjΤ߲ 
       - T_RELEASE_LOCK_AND_DISPATCH(lockobj, dspreq)
       - I_ACQUIRE_LOCK(lockobj)
       - I_ACQUIRE_NESTED_LOCK(lockobj, lockobj1)
          lockobjΤߥå  
       - I_RELEASE_LOCK(lockobj)
       - I_RELEASE_NESTED_LOCK(lockobj, lockobj1)
          lockobjΤ߲ 

  
   - CCB/EXCCB
     - CCB
       - INIT    prcid
       - LOCKOBJ tsk_lock
       - LOCKOBJ obj_lock
       - QUEUE   *p_ready_queue;
       - UINT    *p_ready_primap;
       - TCB     **p_runtsk;
       - TCB     **p_schedtsk;
       - BOOL    *p_enadsp;
       - TMEVTN  *p_tmevt_heap;
       - UINT    *p_last_index; ।٥ȥҡפΥǥå
       - CBTCB   tsk;
       - CBTCB   sem;
       - CBTCB   flg;
       - CBTCB   dtq;
       - CBTCB   mbx;
       - CBTCB   mpf;
       - CBTCB   cyc;
       - FP      p_activate_r;
       - FP      p_call_cychdr;  
    - CCBϿƤν
	  EXCCBϳƥ⥸塼ν롼(xxx_initialize())ǽ롥
      θ塤EXCCBCCB˥ԡԤ롥

  
   - åȰ¸
      - åȰ¸¿JSPͥȶ̤Ǥ롥ǤϡJSP
        ͥΥåȰ¸FDMPͥήѤ뤿ξȤơNios2
        ˤ롤JSPͥFDMPͥΥåȰ¸ĤƤ
        Ȥ롥
      - cpu_config.h : ѹ
         - init_tsk_lock() :  ɲ
            ͤEXCCB tsk_lock_ptr Ͽ 
         - init_obj_lock() :  ɲ
            ͤEXCCB obj_lock_ptr Ͽ
      - cpu_context.h : ѹ
         - activate_context(CCB *ccb, TCB *tcb)
           CCBϿƤץåactivate_rͤѤ褦ѹ
      - cpu_support.S : ѹ
         ret_int
         ret_exc
          TCBterflgåơtrueʤХǥѥå㡼
         activate_r
          åǤϤʤtinibtaskexinf褦ѹ
         㳰Υå
          call_texrtn  dispatch_call_texrtn ѹ
      - makeoffset.c : ѹ
          terflg, tinib, task, exinf ΥեåȤ褦ѹ
      - nios2.h
          Mutexȥɥ饤Фɲ
      - mp_config.c  : ɲ
        - ưƱѴؿ
           - mp_initialize(void) : ƱѤΥǡ(ޥץåΤ߼¹)
           - mp_init_sync(void)  : ޥץåˤ
           - mp_start(void)      : ץåEXCCBνԤ
        - åѴؿ
           - local_acquire_lock(LOCKOBJ *lockobj)
           - local_release_lock(LOCKOBJ *lockobj)
      - mp_config.h  : ɲ
        - ץåߴؿ
           - raise_ipi(INT procid)   : ץåֳߤȯ
           - clear_ipi(void)         : ץåֳߤΥꥢ
           - hw_ipi_initialize(void) : ץåֳߤ˴ؤ
  
  
   - ǥ쥯ȥե빽
      ƥեε
        N : 
        S : 󥰥Ʊ
        D : ޥץåѤ˼줿
      - ./include : 󥯥롼ɥǥ쥯ȥ
         - N : ipi.h        : ץåֳߴϢδؿextern
         - S : itron.h      : ITRONͶ̵Υǡޥ
         - D : kernel.h     : ITRON4.0ɸ।󥯥롼ɥե
         - S : kernel_cfg.h : kernel_cfg.c ѥ󥯥롼ɥե
         - S : kernel_debug.h : ITRON4.0 ǥХåѥ󥯥롼ɥե
         - S : logtask.h    : ƥ
         - S : s_services.h : ǥХɥ饤 ɸ।󥯥롼ɥե
         - S : serial.h     : ꥢ륤󥿥եɥ饤
         - S : sil.h        : ƥ।󥿥ե쥤ʥåȶ
         - D : t_config.h   : åȰ¸
         - S : t_services.h : ץꥱ ɸ।󥯥롼ɥե
         - S : t_stddef.h   : ͥ롦ץꥱ ̥󥯥롼ɥե
         - S : t_syslog.h   : ƥǽ
         - S : timer.h      : ƥ९åɥ饤
      - ./kernel : ͥ붦
         - D : banner.c      : ͥ뵯ưåν
         - D : check.h       : 顼åѥޥ
         - N : class.c       : 饹⥸塼
         - N : class.h       : 饹⥸塼
         - D : cyclic.c      : ϥɥ鵡ǽ
         - D : cyclic.h      : ϥɥ鵡ǽ
         - D : dataqueue.c   : ǡ塼ǽ
         - D : dataqueue.h   : ǡ塼ǽ
         - D : eventflag.c   : ٥ȥե饰ǽ
         - D : eventflag.h   : ٥ȥե饰ǽ
         - S : exception.c   : CPU㳰ǽ ե
         - S : exception.h   : CPU㳰ǽ إåե
         - D : interrupt.c   : ߴǽ
         - D : interrupt.h   : ߴǽ
         - D : fdmp_kernel.h : FDMPͥ ɸ।󥯥롼ɥե
         - N : lock.h        : å֥Ȥ
         - D : mailbox.c     : ᡼ܥåǽ
         - D : mailbox.h     : ᡼ܥåǽ
         - D : mempfix.c     : Ĺס뵡ǽ
         - D : mempfix.h     : Ĺס뵡ǽ
         - S : queue.h       : 塼饤֥
         - D : semaphore.c   : ޥեǽ
         - D : semaphore.h   : ޥեǽ
         - D : startup.c     : ͥνȽλ 
         - D : sys_manage.c  : ƥִǽ
         - S : syslog.c      : ƥǽ ե
         - S : syslog.h      : ƥǽ إåե
         - D : task.c        : ⥸塼
         - D : task.h        : ⥸塼
         - D : task_except.c : 㳰׵
         - D : task_manage.c : ǽ
         - D : task_sync.c   : °Ʊǽ
         - D : time_event.c  : ।٥ȴ⥸塼
         - D : time_event.h  : ।٥ȴ⥸塼
         - S : time_manage.c : ƥǽ
         - D : wait.c        : Ԥִ⥸塼
         - D : wait.h        : Ԥִ⥸塼
      - ./systask : ƥॿ
         - S : logtask.c    : ƥ
         - S : logtask.cfg  : ƥΥե졼ե
         - S : newlibrt.c   : newlibݡȥե
         - S : serial.c     : ꥢ륤󥿥եɥ饤
         - S : serial.cfg   : ꥢ륤󥿥եɥ饤ФΥե졼ե
         - S : timer.c      : ƥ९åɥ饤
         - S : timer.cfg    : ƥ९åɥ饤ФΥե졼ե
         - N : ipi.c        : ץåֳߥɥ饤
         - N : ipi.cfg      : ץåֳߤΥե졼ե
      - ./library : ͥ饤֥
         - S : log_output.c : ƥΥեޥåȽ
         - S : strerror.c   : 顼åʸ֤ؿ
         - S : t_perror.c   : 顼åν
         - S : vasyslog.c   : ѿΥƥ饤֥
      - ./config/nios2      : ץå¸ Nios2
         - D : Makefile.config : ץå¸Makefile
         - S : cpu_config.c  : ץå¸⥸塼 ե
         - D : cpu_config.h  : ץå¸⥸塼 إåե
         - D : cpu_context.h : ƥ롼
         - S : cpu_defs.h    : ץå˰¸
         - S : cpu_insn.h    : ץåü̿Υ饤ؿ
         - D : cpu_support.S : ץå¸⥸塼 ֥
         - S : hw_serial.cfg : SIOɥ饤СNios2 UARTѡˤΥե졼ե
         - S : hw_serial.h   : ꥢI/OǥХSIO˥ɥ饤СNios2 UARTѡ
         - S : hw_timer.h    : ץå¸ޥ⥸塼
         - D : makeoffset.c  : եåȾե
         - N : mp_config.c   : ޥץåݡȥ⥸塼 ե
         - N : mp_config.h   : ޥץåݡȥ⥸塼 إåե
         - S : nios2.c       : Nios2ɸڥեѥɥ饤 ե
         - S : nios2.h       : Nios2ɸڥեѥɥ饤 إåե
         - S : start.S       : ͥѤΥȥåץ⥸塼
         - S : tool_config.h : ȯĶ¸⥸塼
         - S : tool_defs.h   : ȯĶ˰¸
      - ./config/nios2/nios2_dev_board/ : ƥ¸
         - S : Makefile.config : ƥ¸Makefile
         - D : nios2elf_PE1.l  : 󥫥ץ
         - D : nios2elf_PE2.l  : 󥫥ץ
         - S : sys_config.c    : åȥƥ¸⥸塼 ե
         - S : sys_config.h    : åȥƥ¸⥸塼 إåե
         - D : sys_defs.h      : ƥ˰¸
         - S : sys_support.S   : åȥƥ¸⥸塼 ֥         
  
      - ./config/microblaze/ : ץå¸Microbalze
         - D : Makefile.config : ץå¸Makefile
         - S : cpu_config.c  : ץå¸⥸塼 ե
         - D : cpu_config.h  : ץå¸⥸塼 إåե
         - D : cpu_context.h : ƥ롼 
         - S : cpu_defs.h    : ץå˰¸
         - S : cpu_insn.h    : ץåü̿Υ饤ؿ
         - D : cpu_support.S : ץå¸⥸塼 ֥
         - S : hw_serial.cfg : SIOɥ饤СMicroblaze UART LiteѡˤΥե졼ե
         - S : hw_serial.h   : ꥢI/OǥХSIO˥ɥ饤СMicroBlaze opb_uartѡ
         - S : hw_timer.h    : ץå¸ޥ⥸塼
         - D : makeoffset.c  : եåȾե
         - D : mbelf.l       : 󥫥ץ      
         - D : mbelf_rom.l   : ROMб󥫥ץ
         - S : microblaze.c  : ɸڥեѥɥ饤 ե
         - D : microblaze.h  : ɸڥեѥɥ饤 إåե
         - S : microblaze_asm.inc : Microblaze֥ե
         - N : mp_config.c   : ޥץåݡȥ⥸塼 ե
         - N : mp_config.h   : ޥץåݡȥ⥸塼 إåե
         - S : start.S       : ͥѤΥȥåץ⥸塼
      - ./config/microblaze/pe1/ : ƥ¸MireMulti
         - S : Makefile.config : ƥ¸Makefile
         - S : sys_defs.h      : ƥ˰¸
         - S : sys_config.c    : åȥƥ¸⥸塼 ե
         - S : sys_config.h    : åȥƥ¸⥸塼 إåե
         - S : sys_support.S   : åȥƥ¸⥸塼 ֥

 */ 

/** \file
 *	ͥνȽλ
 */

#include "fdmp_kernel.h"
#include "class.h"
#include "time_event.h"
#include "syslog.h"
#include "cyclic.h"

/**
 *  ͥư֥ե饰
 */
BOOL	iniflg;

/**
 *  ͥν
 */

void
kernel_start()
{
	/*
	 *  åȰ¸ν
	 */
	cpu_initialize();
	sys_initialize();
	tool_initialize();
	
	/*
	 *  ƥǽν
	 */
	syslog_initialize();

	/*
	 *  ưåɽ
	 */
	print_banner();

	/*
	 * EXCCBνƱ
	 */
#if NO_PROC != 1    
	if(MASTER_PROC()){
		/* ¾ץåȤƱѥǡν */
		mp_initialize();
		syslog(LOG_NOTICE,"Start %d processors.", NO_PROC);
	}else{
		/* ¾ץåϥޥץåˤԤ */
		syslog(LOG_NOTICE,"waiting for EXCCB initialized");
		mp_init_sync();
		syslog(LOG_NOTICE,"OK");
	}
#endif /* NO_PROC != 1 */
    
	/*
	 * EXCCBγȥϿ(IDȥå)
	 */
	exccb_initialize();

	/*
	 *  ƥ⥸塼ν
	 *
	 *  ।٥ȴ⥸塼¾Υ⥸塼˽
	 *  ɬפ롥
	 */
	tmevt_initialize();
	object_initialize();

	/*
	 *  롼μ¹
	 */ 
	call_inirtn();

	/*
	 * ¾ΥץåƱ
	 * EXCCBνԤ
	 */
#if NO_PROC != 1        
	mp_start();
#endif /* NO_PROC != 1 */
    
	/*
	 * EXCCBơ֥ξCCBơ֥Ѵ
	 */
	ccb_convert();

	/*
	 * TA_ACTꤵ줿εư
	 */
	task_init_activate();

	/*
	 * TA_STAꤵ줿ϥɥεư
	 */
	cyclic_init_sta();

	/*
	 *  ͥưγ
	 */
	iniflg = TRUE;
	exit_and_dispatch();
}


/**
 *  ͥνλ
 */

void
kernel_exit()
{
	/*
	 *  ߤػ
	 */
	if (!sense_lock()) {
		if (sense_context()) {
			i_lock_cpu();
		}
		else  {
			t_lock_cpu();
		}
	}
	iniflg = FALSE;

	/*
	 *  λ롼μ¹
	 */
	call_terrtn();

	/*
	 *  atexit νȥǥȥ饯μ¹
	 */
	call_atexit();

	/*
	 *  ƥǽνλ
	 */
	syslog_terminate();

	/*
	 *  åȰ¸νλ
	 */
	cpu_terminate();
	sys_exit();
}
