/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2005 by Takagi Nobuhisa
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/itron/jsp/itron.hpp
 *  \brief  ITRON 4.0dl̋ʒ`̖͕
 */
#ifndef TOPPERS_ITRON_JSP_ITRON_HPP_
#define TOPPERS_ITRON_JSP_ITRON_HPP_

#include "toppers/config.hpp"
#include <boost/cstdint.hpp>

namespace toppers
{
  namespace itron
  {
    namespace jsp
    {

      typedef boost::int_least8_t B;
      typedef boost::uint_least8_t UB;
      typedef boost::int_least8_t VB;
      typedef boost::int_least16_t H;
      typedef boost::uint_least16_t UH;
      typedef boost::int_least16_t VH;
      typedef boost::int_least32_t W;
      typedef boost::uint_least32_t UW;
      typedef boost::int_least32_t VW;

      typedef boost::uint_least32_t VP;
      typedef boost::uint_least32_t VP_INT;

      typedef boost::int_least32_t INT;
      typedef boost::uint_least32_t UINT;

      typedef boost::int_least32_t ID;
      typedef boost::int_least32_t ATR;
      typedef boost::int_least32_t PRI;
      typedef boost::uint_least32_t RELTIM;
      typedef boost::uint_least32_t FP;
      typedef boost::uint_least32_t SIZE;

      typedef boost::int_least32_t ER;
      typedef boost::int_least32_t ER_ID;
      typedef boost::int_least32_t ER_INT;

    }
  }
}

#endif  // ! TOPPERS_ITRON_JSP_ITRON_HPP_
