/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *                2003      by  Advanced Data Controls, Corp
 *  Copyright (C) 2006      by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN      
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: perf_hw.h,v 1.2 2007/07/26 02:31:20 honda Exp $
 */

/*
 *  ǽɾѳ
 */

#ifndef _PERF_HW_H_
#define _PERF_HW_H_

#include <s_services.h>

/*
 * USECؤѴ
 */
#define PTIM_TO_USEC(clock)    (clock)

/*
 * ޤΥͤɤ߹
 */
Inline UINT
ptimer_get_current(void)
{
    return(0xFFFFFFFF - sil_rew_mem((void *)EB_TIMER01_0_VALUE));    
}


/*
 * 
 */
Inline void
ptimer_init(void)
{
    /*
     * 󥿡å1MHz
     */
    sil_wrw_mem((void *)EB_SYS_CTRL, 
                (sil_rew_mem((void *)EB_SYS_CTRL)) | EB_SYS_CTRL_TIMER01_1MHZ);
    
    /*  */
    sil_wrw_mem((void *)EB_TIMER01_0_CTRL, 0x00);
    /* ͤ򥻥å */
    sil_wrw_mem((void *)EB_TIMER01_0_LOAD, 0xFFFFFFFF);
    /* ޥȡ, 32bit */
    sil_wrw_mem((void *)EB_TIMER01_0_CTRL,
                (EB_TIMER_CTRL_TIMER_EN|EB_TIMER_CTRL_PERIODIC
                 |EB_TIMER_CTRL_TIMESIZE_32));    
}


#endif  /* _PERF_HW_H_ */

