/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_defs.h,v 1.1 2005/04/04 12:15:30 honda Exp $
 */


/** \file
 *  ƥ˰¸MultiMedia
 *
 *  Υ󥯥롼ɥեϡkernel.h  sil.h ǥ󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥
 *  롼ɤˡt_stddef.h  itron.h 󥯥롼ɤΤǡ
 *  ˰¸Ƥ褤
 *
 *  MPˤѹ
 *    - PRCIDɲ 
 */


#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

#define MB_TEMPLATE_SYSTEM


/**
 *  ưåΥå̾
 */
#ifdef PE1
#define	TARGET_NAME	"MultiMedia(Microblaze PE1)"
#else /* PE2 */
#define	TARGET_NAME	"MultiMedia(Microblaze PE2)"
#endif 

/*
 *  ե졼¸
 */

/*
 * ץå
 */
#define NO_PROC 2

/**
 * ץåID
 */
#ifdef PE1
#define PRCID 1
#else /* PE2 */
#define PRCID 2
#endif

/**
 *   åΰ
 */
#define STACKTOP		0x2000    /* Ωѥåν */

/**
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK		54000

/**
 *  ƥå
 */
#define	TIC_NUME	1		/* ƥåμʬ */
#define	TIC_DENO	1		/* ƥåμʬ */

#ifdef PE1
#define PERI_BASEADDR  0x00000000
#else /* PE2 */
#define PERI_BASEADDR  0x01000000
#endif

/**
 *  INTC Υ١ɥ쥹
 */
#define INTC_BASE		(0xF0000200 + PERI_BASEADDR)

/**
 *  TIMER Υ١ɥ쥹
 */
#define TIMER_BASE		(0xF0000300 + PERI_BASEADDR)

/**
 * ͥǻѤ UART Υ١ɥ쥹
 */
#define UART_BASE		(0xF0000400 + PERI_BASEADDR)

/**
 * ԥåϩΥ١ɥ쥹
 */
#define LOCK_BASE		(0xf0200000 + PERI_BASEADDR)

#define TSK_LOCK_REG	0x0
#define OBJ_LOCK_REG	0x4

/**
 * ץåֳ߲ϩΥ١ɥ쥹
 */
#define INTERPROC_BASE	(0xf0200100 + PERI_BASEADDR)


/**
 *  TIM ߤγֹ
 */
#define TIMINTLVL		1

/**
 * UART ߤγֹ
 */
#define UARTINTLVL		2

/**
 *  ץåֳ߲ϩγֹ
 */
#define INTERPROCLVL	3


/**
 *  ꥢݡֹ˴ؤ
 */
#define TNUM_PORT   1   /* ݡȤ륷ꥢݡȤο */
#define TNUM_SIOP   1   /* ݡȤ륷ꥢI/OݡȤο */

/**
 *  ƥॿ˴ؤ
 */
#define	LOGTASK_PORTID	1	/* ƥϤ륷ꥢݡֹ */


/**
 *  ԤΤ
 */
#define SIL_DLY_TIM1	420
#define SIL_DLY_TIM2	90

/**
 * ưΥå
 * åONˤ롥
 */
//#define D_CACHE_ENABLE
//#define I_CACHE_ENABLE


#endif /* _SYS_DEFS_H_ */
