/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_defs.h,v 1.1 2005/04/03 13:33:19 honda Exp $
 */


/*
 *  ƥ˰¸MIRE-MULTI
 *
 *  Υ󥯥롼ɥեϡkernel.h  sil.h ǥ󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥
 *  롼ɤˡt_stddef.h  itron.h 󥯥롼ɤΤǡ
 *  ˰¸Ƥ褤
 */


#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

#define MB_TEMPLATE_SYSTEM


/*
 *  ưåΥå̾
 */
#define	TARGET_NAME	"MIRE-MULTI(Microblaze PE4)"

/*
 *  ե졼¸
 */

/*
 * ץåID
 */
#define PRCID 4

/*
 *   åΰ
 */                 
#define STACKTOP    0x8000    /* Ωѥåν */

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK	 50000

/*
 *  ƥå
 */
#define	TIC_NUME	1		/* ƥåμʬ */
#define	TIC_DENO	1		/* ƥåμʬ */


/*
 *  INTC Υ١ɥ쥹
 */
#define INTC_BASE 0xF3000200

/*
 *  TIMER Υ١ɥ쥹
 */
#define TIMER_BASE 0xF3000300

/*
 * ͥǻѤ UART Υ١ɥ쥹
 */
#define UART_BASE 0xF3000600

/*
 * ԥåϩΥ١ɥ쥹
 */
#define LOCK_BASE		0xf3200000

#define TSK_LOCK_REG	0x18
#define OBJ_LOCK_REG	0x1c

/*
 * ץåֳ߲ϩΥ١ɥ쥹
 */
#define INTERPROC_BASE		0xf3200100


/*
 *  TIM ߤγֹ
 */
#define TIMINTLVL        1

/*
 * UART ߤγֹ
 */
#define UARTINTLVL       3

/*
 *  ץåֳ߲ϩγֹ
 */
#define INTERPROCLVL     4


/*                                                                             
 *  ꥢݡֹ˴ؤ      
 */
#define TNUM_PORT   1   /* ݡȤ륷ꥢݡȤο */
#define TNUM_SIOP   1   /* ݡȤ륷ꥢI/OݡȤο */

/*
 *  ƥॿ˴ؤ
 */
#define	LOGTASK_PORTID	1	/* ƥϤ륷ꥢݡֹ */


/*
 *  ԤΤ
 */
#define SIL_DLY_TIM1    420
#define SIL_DLY_TIM2    90

/*
 * ưΥå
 * åONˤ롥
 */
//#define D_CACHE_ENABLE
//#define I_CACHE_ENABLE


#endif /* _SYS_DEFS_H_ */
