/*
 *  TOPPERS/FDMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Function Distributed Multiprocessor Kernel
 *
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: fdmp_kernel.h,v 1.2 2006/03/14 04:37:54 honda Exp $
 */

/** \file
 *	FDMPͥ ɸ।󥯥롼ɥե
 *
 *  Υ󥯥롼ɥեϡͥץΥե
 *  ɬ󥯥롼ɤ٤ɸ।󥯥롼ɥեǤ롥
 *
 *  ֥Υե䥷ƥॳե졼ե
 *  뤫餳Υե򥤥󥯥롼ɤϡ_MACRO_ONLY 
 *  ȤǡޥʳεҤȤǤ롥
 *
 */

#ifndef _FDMP_KERNEL_H_
#define _FDMP_KERNEL_H_

/*
 *  ͥ̾Υ͡
 */
#include "fdmp_rename.h"

/*
 *  ץꥱȶ̤Υ󥯥롼ɥե
 */
#include <kernel.h>

/*
 *  åȰ¸
 */
#include <t_config.h>

/*
 *  եñ̤ǥ饤֥경˥󥯥롼ɤ
 */
#ifdef KERNEL_LIB_BY_FUNC
#include "all_func_def.h"
#endif /* KERNEL_LIB_BY_FUNC */

/*
 *  ֥IDκǾͤ
 */
#define	TMIN_ID	1	

/*
 *  ͥ٤ʳ
 */
#define	TNUM_TPRI	(TMAX_TPRI - TMIN_TPRI + 1)
#define	TNUM_MPRI	(TMAX_MPRI - TMIN_MPRI + 1)

/*
 *  ͥѤޥ
 */
#define SYSCALL

/*
 *  إåեʤ⥸塼δؿѿ
 */
#ifndef _MACRO_ONLY

/**
 *  ƥ⥸塼νkernel_cfg.c
 */
extern void	object_initialize(void);

/**
 *  롼μ¹ԡkernel_cfg.c
 */
extern void	call_inirtn(void);

/**
 *  λ롼μ¹ԡkernel_cfg.c
 */
extern void	call_terrtn(void);

/**
 *  ưåɽbanner.c
 */
extern void	print_banner(void);

/**
 *  ͥνλstartup.c
 */
extern void	kernel_exit(void);

/**
 *  ͥư֥ե饰startup.c
 */
extern BOOL	iniflg;

#endif /* _MACRO_ONLY */
#endif /* _FDMP_KERNEL_H_ */
